<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <v-container class="studium-tab">
    <!-- Title: Description & Edit or Log History -->
    <v-row no-gutters class="pt-2 pb-0" align="center" justify="space-between">
      <!-- Title -->
      <v-col cols="auto">
        <span class="studium-title">
          <template v-if="!showVersions">{{ $t('courses.description.description') }}</template>
          <template v-else>{{ $t('courses.description.revisions') }}</template>
        </span>
      </v-col>

      <!-- Edit Button -->
      <v-col cols="auto">
        <v-btn
          v-if="!editMode && !showVersions"
          class="studium-button"
          color="primary"
          text
          large
          :ripple="false"
          @click="editMode = true"
        >
          {{ $t('courses.description.edit') }}
          <v-icon color="primary" right medium> mdi-pencil </v-icon>
        </v-btn>
      </v-col>
    </v-row>

    <!-- High-level history information or return to description -->
    <v-row no-gutters class="pb-2">
      <v-col cols="auto" class="studium-clickable-text" @click="showVersions = !showVersions">
        <!-- Click to show versions -->
        <template v-if="!showVersions">
          {{ versionText }}
        </template>

        <!-- Click to go back -->
        <template v-else>
          <v-icon size="21" class="ml-n1">mdi-chevron-left</v-icon>
          <span> {{ $t('courses.description.back') }}</span>
        </template>
      </v-col>
    </v-row>

    <!-- Edit feedback  -->
    <suspense-mutation
      :mutation="editDescriptionMutation"
      :success-timeout="5000"
      transition="slide-y-transition"
      transition-mode="out-in"
    >
      <!-- Error -->
      <template #error>
        <v-row no-gutters>
          <v-col>
            <v-alert class="studium-alert" dense text type="error">
              {{ editDescriptionMutationError.message }}
            </v-alert>
          </v-col>
        </v-row>
      </template>

      <!-- Success -->
      <template #success>
        <v-row no-gutters>
          <v-col>
            <v-alert class="studium-alert" dense text type="success"> {{ $t('courses.description.succes') }} </v-alert>
          </v-col>
        </v-row>
      </template>
    </suspense-mutation>

    <!-- Description, Versions or Editor  -->
    <transition name="fade" mode="out-in">
      <!-- Versions -->
      <div v-if="showVersions" key="history">
        <course-description-versions :course-code="course.code" />
      </div>

      <!-- Editor or description -->
      <div v-else key="description">
        <!-- Editor -->
        <course-description-editor
          v-if="editMode"
          :edit-content-mutation="editDescriptionMutation"
          :course-description="course.description.content"
          :course-code="course.code"
          @close="editMode = false"
        />

        <!-- Description -->
        <template v-else>
          <!-- Placeholder -->
          <content-placeholder v-if="descriptionEmpty" brackets class="mt-4" @click="editMode = true">
            <template #first>{{ $t('courses.description.nothing') }}</template>
            <template #second> {{ $t('courses.description.start') }}</template>
          </content-placeholder>

          <!-- Description -->
          <div v-else v-dompurify-html="course.description.content" />
        </template>
      </div>
    </transition>

    <!-- Dialog windows for reporting a description error -->
    <course-description-report-dialog :open.sync="reportDialog" :course-code="course.code" />

    <!-- Something wrong ?  -->
    <v-row v-if="!showVersions && !editMode" no-gutters class="pt-6" justify="end">
      <v-col v-show="!editMode" cols="12" class="d-flex flex-column align-center align-md-end">
        <a class="studium-clickable-text" @click="reportDialog = true">
          {{ $t('courses.description.wrong') }}
        </a>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@nuxtjs/composition-api'
import { format, parseISO } from 'date-fns'

import { useChangeCourseDescriptionMutation } from '~/apollo/_generated'
import { useErrorHandler, useRouterHash } from '~/util/composables/'

export default defineComponent({
  props: {
    // Course
    course: {
      type: Object,
      default: null,
    },
  },
  setup(props) {
    const showVersions = ref(false)
    const editMode = ref(false)
    const reportDialog = useRouterHash('report')

    // If the description is empty
    const descriptionEmpty = computed(
      () =>
        props.course.description.content === '<p></p>' ||
        props.course.description.content === '<h1></h1>' ||
        props.course.description.content === '<h2></h2>'
    )

    // The editor component will be in charge of mutating the description
    const editDescriptionMutation = useChangeCourseDescriptionMutation({})
    const editDescriptionMutationError = useErrorHandler(editDescriptionMutation)

    // Last version date
    const lastVersionDate = computed(() => format(parseISO(props.course.description.lastVersionDate), 'dd/MM/yyyy'))

    // Last version user
    const lastVersionUser = computed(() => {
      // If a versiob is available
      if (props.course.description.versionsAmount > 0) {
        return `${props.course.description.lastVersionUser.firstName} ${props.course.description.lastVersionUser.lastName}`
      }

      return 'None'
    })

    // Version text
    const versionText = computed(() => {
      // If a version is available, show the date and the user
      if (props.course.description.versionsAmount > 0) {
        return `${props.course.description.versionsAmount} ${
          props.course.description.versionsAmount === 1 ? 'revision' : 'revisions'
        } - Last updated on ${lastVersionDate.value} by ${lastVersionUser.value}`
      }
      return 'No revisions yet'
    })

    return {
      showVersions,
      editMode,
      reportDialog,
      descriptionEmpty,
      editDescriptionMutation,
      editDescriptionMutationError,
      lastVersionDate,
      lastVersionUser,
      versionText,
    }
  },
})
</script>
